Redmine - Defect #13138

Generating PDF of issue causes UndefinedConversionError with htmlentities gem
2013-02-12 12:03 - Mathew C

Status: Closed Start date:

Priority: Low Due date:

Assignee: % Done: 0%
Category: PDF export Estimated time: 0.00 hour
Target version: 224

Resolution: Fixed Affected version: 222
Description

When attempting to create a PDF of an issue an internal error occurs. | think it is caused by the '-' character (long dash or hyphen),
because when | changed it to a standard dash '-' the PDF generated correctly.

In the log is the following:

Encoding: :UndefinedConversionError ("\xE2" from ASCII-8BIT to UTF-8):
lib/plugins/rfpdf/lib/tcpdf.rb:4346:in “unhtmlentities'
lib/plugins/rfpdf/lib/tcpdf.rb:3542:in "block in writeHTML'
lib/plugins/rfpdf/lib/tcpdf.rb:3509:in “each'
lib/plugins/rfpdf/lib/tcpdf.rb:3509:in "writeHTML'
lib/plugins/rfpdf/lib/tcpdf.rb:3620:1in "writeHTMLCell'
lib/redmine/export/pdf.rb:129:in "'RDMwriteHTMLCell'
lib/redmine/export/pdf.rb:681:in "block in issue_to_pdf'
lib/redmine/export/pdf.rb:668:in “each'
lib/redmine/export/pdf.rb:668:in " issue_to_pdf'
app/controllers/issues_controller.rb:124:in “block (2 levels) in show'
app/controllers/issues_controller.rb:116:in " show'

This is the output of RAILS_ENV=production rake about

About your application's environment

Ruby version 1.9.3 (x86_64-1inux)
RubyGems version 1.8.11

Rack version 1.4

Rails version 3.2.11

Active Record version 3.2.11

Action Pack version 3.2.11

Active Resource version 3.2.11

Action Mailer version 3.2.11

Active Support version 3.2.11

Middleware Rack::Cache, ActionDispatch::Static, Rack::Lock, #
<ActiveSupport::Cache::Strategy::LocalCache: :Middleware:0x000000025c99%9a8>, Rack::Runtime,
Rack: :MethodOverride, ActionDispatch::RequestId, Rails::Rack::Logger,

ActionDispatch: :ShowExceptions, ActionDispatch::DebugExceptions, ActionDispatch::Remotelp,
ActionDispatch::Callbacks, ActiveRecord::ConnectionAdapters::ConnectionManagement,
ActiveRecord: :QueryCache, ActionDispatch::Cookies, ActionDispatch::Session::CookieStore,
ActionDispatch::Flash, ActionDispatch::ParamsParser, ActionDispatch::Head,
Rack::ConditionalGet, Rack::ETag, ActionDispatch::BestStandardsSupport,
OpenIdAuthentication

Application root /var/www/redmine-2.2.2
Environment production
Database adapter mysqlz2

Database schema version 20121026003537

Related issues:
Has duplicate Redmine - Defect #12309: rfpdf fails to include htmlentities ge... Closed

Associated revisions
http://text-symbols.com/html/entities-and-descriptions/

Revision 11399 - 2013-02-15 14:24 - Toshi MARUYAMA
not use htmlentities gem in rfpdf plugin (#13138)

Contributed by Jun NAITOH.

Revision 11400 - 2013-02-15 15:32 - Toshi MARUYAMA
Merged r11399 from trunk to 2.2-stable (#13138)

not use htmlentities gem in rfpdf plugin.

Contributed by Jun NAITOH.

History

#1 - 2013-02-12 12:05 - Mathew C

Interestingly, PDF link works correctly for this issue, which was unexpected.

#2 - 2013-02-12 12:36 - Toshi MARUYAMA

| cannot reproduce on ruby-1.9.3-p374 in English.
What is your language and what is "general_pdf_encoding"?
English: source:tags/2.2.2/config/locales/en.yml#l 143

#3 - 2013-02-12 12:37 - Toshi MARUYAMA
- File ecookbook-1.pdf added

| forgot attaching PDF.

#4 - 2013-02-13 15:12 - Jun NAITOH
| tried on CentOS 6.

| added Gemfile.local file.
gem 'htmlentities'

| reproduced on ruby 1.9.3p125 in English.
But, | cannot reproduced on ruby 1.8.7 in English.

I think it is the same problem as #12309.

#5 - 2013-02-14 00:54 - Mathew C
Toshi MARUYAMA wrote:

| cannot reproduce on ruby-1.9.3-p374 in English.
Output from ruby --version is: ruby 1.9.3p0 (2011-10-30 revision 33570) [x86_64-linux]
Server OS is Ubuntu 12.04 LTS.

What is your language and what is "general_pdf_encoding"?
English: source:tags/2.2.2/config/locales/en.yml#l 143

Language is english & "general_pdf_encoding" is set to UTF-8.

#6 - 2013-02-15 13:34 - Jun NAITOH
- File htmlentities_delete r11398.diff added
| think to this probrem caused by htmlentities gem on ruby 1.9.3

Redmine PDF export don't use htmlentities gem, now.
| wrote htmlentities gem delete patch.

#7 - 2013-02-15 14:28 - Toshi MARUYAMA

- Subject changed from Generating PDF of issue causes UndefinedConversionError in tcpdf.rb to Generating PDF of issue causes
UndefinedConversionError with htmlentities gem
https://www.redmine.org/projects/redmine/repository/svn/entry/tags/2.2.2/config/locales/en.yml#L143
https://www.redmine.org/issues/12309
https://www.redmine.org/projects/redmine/repository/svn/entry/tags/2.2.2/config/locales/en.yml#L143

#8 - 2013-02-15 14:36 - Toshi MARUYAMA

- Target version set to 2.2.4

#9 - 2013-02-15 16:25 - Toshi MARUYAMA
- Status changed from New to Closed

- Resolution set to Fixed

Committed in trunk r11399 and 2.2-stable r11400, thanks.

Files

ecookbook-1.pdf 309 KB 2013-02-12 Toshi MARUYAMA

htmlentities_delete_r11398.diff 1.63 KB 2013-02-15 Jun NAITOH
https://www.redmine.org/projects/redmine/repository/svn/revisions/11399
https://www.redmine.org/projects/redmine/repository/svn/revisions/11400
http://www.tcpdf.org

